9ae3a8
From 8c0c745cfd6e5e8e366449ed421edb250f24abf1 Mon Sep 17 00:00:00 2001
9ae3a8
From: Max Reitz <mreitz@redhat.com>
9ae3a8
Date: Sat, 13 Jun 2015 16:22:08 +0200
9ae3a8
Subject: [PATCH 14/42] iotests: Add test for qcow2 L1 table update
9ae3a8
9ae3a8
Message-id: <1434212556-3927-15-git-send-email-mreitz@redhat.com>
9ae3a8
Patchwork-id: 66033
9ae3a8
O-Subject: [RHEL-7.2 qemu-kvm PATCH 14/42] iotests: Add test for qcow2 L1 table update
9ae3a8
Bugzilla: 1129893
9ae3a8
RH-Acked-by: Jeffrey Cody <jcody@redhat.com>
9ae3a8
RH-Acked-by: Fam Zheng <famz@redhat.com>
9ae3a8
RH-Acked-by: Stefan Hajnoczi <stefanha@redhat.com>
9ae3a8
9ae3a8
BZ: 1129893
9ae3a8
9ae3a8
Updating the L1 table should not result in random data being written.
9ae3a8
This adds a test for that.
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
Reviewed-by: Eric Blake <eblake@redhat.com>
9ae3a8
Signed-off-by: Kevin Wolf <kwolf@redhat.com>
9ae3a8
(cherry picked from commit 1b2dd0bee6bd03045b90c8a7549c8134466b2938)
9ae3a8
Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
9ae3a8
9ae3a8
Conflicts:
9ae3a8
	tests/qemu-iotests/group
9ae3a8
9ae3a8
Signed-off-by: Max Reitz <mreitz@redhat.com>
9ae3a8
---
9ae3a8
 tests/qemu-iotests/107     | 61 ++++++++++++++++++++++++++++++++++++++++++++++
9ae3a8
 tests/qemu-iotests/107.out | 10 ++++++++
9ae3a8
 tests/qemu-iotests/group   |  1 +
9ae3a8
 3 files changed, 72 insertions(+)
9ae3a8
 create mode 100755 tests/qemu-iotests/107
9ae3a8
 create mode 100644 tests/qemu-iotests/107.out
9ae3a8
9ae3a8
diff --git a/tests/qemu-iotests/107 b/tests/qemu-iotests/107
9ae3a8
new file mode 100755
9ae3a8
index 0000000..cad1cf9
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/107
9ae3a8
@@ -0,0 +1,61 @@
9ae3a8
+#!/bin/bash
9ae3a8
+#
9ae3a8
+# Tests updates of the qcow2 L1 table
9ae3a8
+#
9ae3a8
+# Copyright (C) 2014 Red Hat, Inc.
9ae3a8
+#
9ae3a8
+# This program is free software; you can redistribute it and/or modify
9ae3a8
+# it under the terms of the GNU General Public License as published by
9ae3a8
+# the Free Software Foundation; either version 2 of the License, or
9ae3a8
+# (at your option) any later version.
9ae3a8
+#
9ae3a8
+# This program is distributed in the hope that it will be useful,
9ae3a8
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
9ae3a8
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
9ae3a8
+# GNU General Public License for more details.
9ae3a8
+#
9ae3a8
+# You should have received a copy of the GNU General Public License
9ae3a8
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
9ae3a8
+#
9ae3a8
+
9ae3a8
+# creator
9ae3a8
+owner=mreitz@redhat.com
9ae3a8
+
9ae3a8
+seq="$(basename $0)"
9ae3a8
+echo "QA output created by $seq"
9ae3a8
+
9ae3a8
+here="$PWD"
9ae3a8
+tmp=/tmp/$$
9ae3a8
+status=1	# failure is the default!
9ae3a8
+
9ae3a8
+_cleanup()
9ae3a8
+{
9ae3a8
+	_cleanup_test_img
9ae3a8
+}
9ae3a8
+trap "_cleanup; exit \$status" 0 1 2 3 15
9ae3a8
+
9ae3a8
+# get standard environment, filters and checks
9ae3a8
+. ./common.rc
9ae3a8
+. ./common.filter
9ae3a8
+
9ae3a8
+_supported_fmt qcow2
9ae3a8
+_supported_proto file
9ae3a8
+_supported_os Linux
9ae3a8
+
9ae3a8
+
9ae3a8
+IMG_SIZE=64K
9ae3a8
+
9ae3a8
+echo
9ae3a8
+echo '=== Updates should not write random data ==='
9ae3a8
+echo
9ae3a8
+
9ae3a8
+_make_test_img $IMG_SIZE
9ae3a8
+$QEMU_IO -c 'write 0 64k' "$TEST_IMG" | _filter_qemu_io
9ae3a8
+$QEMU_IO -c "open -o driver=raw $TEST_IMG" -c 'read -p -P 0 196616 65528' \
9ae3a8
+    | _filter_qemu_io
9ae3a8
+
9ae3a8
+# success, all done
9ae3a8
+echo "*** done"
9ae3a8
+rm -f $seq.full
9ae3a8
+status=0
9ae3a8
+
9ae3a8
diff --git a/tests/qemu-iotests/107.out b/tests/qemu-iotests/107.out
9ae3a8
new file mode 100644
9ae3a8
index 0000000..93445b7
9ae3a8
--- /dev/null
9ae3a8
+++ b/tests/qemu-iotests/107.out
9ae3a8
@@ -0,0 +1,10 @@
9ae3a8
+QA output created by 107
9ae3a8
+
9ae3a8
+=== Updates should not write random data ===
9ae3a8
+
9ae3a8
+Formatting 'TEST_DIR/t.IMGFMT', fmt=IMGFMT size=65536 
9ae3a8
+wrote 65536/65536 bytes at offset 0
9ae3a8
+64 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
9ae3a8
+read 65528/65528 bytes at offset 196616
9ae3a8
+63.992 KiB, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
9ae3a8
+*** done
9ae3a8
diff --git a/tests/qemu-iotests/group b/tests/qemu-iotests/group
9ae3a8
index cd8384a..dd3c5fe 100644
9ae3a8
--- a/tests/qemu-iotests/group
9ae3a8
+++ b/tests/qemu-iotests/group
9ae3a8
@@ -86,3 +86,4 @@
9ae3a8
 088 rw auto
9ae3a8
 092 rw auto quick
9ae3a8
 105 rw auto quick
9ae3a8
+107 rw auto quick
9ae3a8
-- 
9ae3a8
1.8.3.1
9ae3a8